## qgis 3.40.11+git20251010+9deff1ff420+18trixie

=== debian/changelog ===
qgis (1:3.40.11+git20251010+9deff1ff420+18trixie) trixie; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for trixie

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 10 Oct 2025 15:20:20 +0000

=== qgis/debian/changelog ===
qgis (1:3.40.11+git20251010+9deff1ff420+36jammy) jammy; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for jammy

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 10 Oct 2025 00:07:11 +0000

## qgis 3.40.11+git20251013+3df52a49d0a+18trixie

=== debian/changelog ===
qgis (1:3.40.11+git20251013+3df52a49d0a+18trixie) trixie; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for trixie

 -- Jürgen E. Fischer <jef@norbit.de>  Tue, 14 Oct 2025 14:24:45 +0000

## qgis 3.40.11+git20251013+3df52a49d0a+40noble-ubuntugis

=== debian/changelog ===
qgis (1:3.40.11+git20251013+3df52a49d0a+40noble-ubuntugis) noble; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for noble-ubuntugis with
    ubuntugis dependencies

 -- Jürgen E. Fischer <jef@norbit.de>  Tue, 14 Oct 2025 04:41:42 +0000

## qgis 3.40.11+git20251013+3df52a49d0a+42plucky

=== debian/changelog ===
qgis (1:3.40.11+git20251013+3df52a49d0a+42plucky) plucky; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for plucky

 -- Jürgen E. Fischer <jef@norbit.de>  Tue, 14 Oct 2025 06:41:43 +0000

=== debian/control ===
Source: qgis
Maintainer: QGIS developers <qgis-developer@lists.osgeo.org>
Uploaders: Jürgen E. Fischer <jef@norbit.de>
Section: science
Priority: optional
Build-Depends:
 bison,
 ca-certificates,
 cmake (>= 2.8),
 debhelper (>= 9),
 dh-python,
 flex,
 gdal-bin,
 grass-dev,
 libexiv2-dev,
 libexpat1-dev,
 libfcgi-dev,
 libgdal-dev (>= 1.11),
 libgeos-dev (>= 3.0.0),
 libgsl-dev,
 libpq-dev,
 libproj-dev,
 libqca-qt5-2-dev,
 libqca-qt5-2-plugins,
 libqscintilla2-qt5-dev,
 libqt5opengl5-dev,
 libqt5serialport5-dev,
 libqt5sql5-sqlite,
 libqt5svg5-dev,
 libqt5xmlpatterns5-dev,
 libdraco-dev,
 qtmultimedia5-dev,
 libqwt-qt5-dev,
 libspatialite-dev,
 libsqlite3-dev,
 libsqlite3-mod-spatialite,
 libzip-dev,
 nlohmann-json3-dev,
 ninja-build,
 ocl-icd-opencl-dev,
 opencl-headers,
 pkgconf,
 pyqt5-dev-tools,
 pyqt5-dev,
 pyqt5.qsci-dev,
 python3-all-dev,
 python3-dev,
 python3-gdal,
 python3-mock,
 python3-nose2,
 python3-owslib,
 python3-psycopg2,
 python3-pyqt5,
 python3-pyqt5.qsci,
 python3-pyqt5.qtmultimedia,
 python3-pyqt5.qtpositioning,
 python3-pyqt5.qtserialport,
 python3-pyqt5.qtsql,
 python3-pyqt5.qtsvg,
 python3-pyqtbuild,
 sip-tools,
 python3-termcolor,
 python3-yaml,
 qt3d5-dev,
 qt3d-assimpsceneimport-plugin,
 qt3d-defaultgeometryloader-plugin,
 qt3d-gltfsceneio-plugin,
 qt3d-scene2d-plugin,
 qtkeychain-qt5-dev,
 qtbase5-dev,
 qtbase5-private-dev,
 qtpositioning5-dev,
 qttools5-dev-tools,
 qttools5-dev,
 libprotobuf-dev,
 protobuf-compiler,
 libzstd-dev,
 git,
 graphviz,
 xvfb,
 xauth,
 xfonts-base,
 xfonts-100dpi,
 xfonts-75dpi,
 xfonts-scalable,
 spawn-fcgi,
 poppler-utils,
 lighttpd,
 locales
Build-Conflicts:
 libqgis-dev,
 qgis-dev
Standards-Version: 3.9.7
Vcs-Browser: https://github.com/qgis/QGIS/
Vcs-Git: https://github.com/qgis/QGIS.git
Homepage: https://qgis.org/
Rules-Requires-Root: no

Package: qgis
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 python3-qgis (= ${binary:Version}),
 qgis-providers (= ${binary:Version}),
 qgis-common (= ${source:Version})
Recommends:
 qgis-plugin-grass
Suggests: gpsbabel
Conflicts: uim-qt3
Description: Geographic Information System (GIS)
 A Geographic Information System (GIS) manages, analyzes, and displays
 databases of geographic information. QGIS supports shape file viewing and
 editing, spatial data storage with PostgreSQL/PostGIS, projection on-the-fly,
 map composition, and a number of other features via a plugin interface. QGIS
 also supports display of various georeferenced raster and Digital Elevation
 Model (DEM) formats including GeoTIFF, Arc/Info ASCII Grid, and USGS ASCII
 DEM.

Package: qgis-common
Architecture: all
Depends:
 libjs-jquery,
 libjs-leaflet,
 qml-module-qtcharts,
 ${misc:Depends}
Description: QGIS - architecture-independent data
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains architecture-independent supporting data files for use
 with QGIS.

Package: libqgis-3d3.40.11
Architecture: any
Section: libs
Depends:
 qt3d-assimpsceneimport-plugin,
 qt3d-defaultgeometryloader-plugin,
 qt3d-gltfsceneio-plugin,
 qt3d-scene2d-plugin,
 ${shlibs:Depends},
 ${misc:Depends}
Description: QGIS - shared 3d library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared 3d library.

Package: libqgis-analysis3.40.11
Architecture: any
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: QGIS - shared analysis library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared analysis library.

Package: libqgis-app3.40.11
Architecture: any
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Replaces: libqgis3.40.11
Description: QGIS - shared app library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared app library.

Package: libqgis-core3.40.11
Architecture: any
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: QGIS - shared core library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared core library.

Package: libqgis-gui3.40.11
Architecture: any
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: QGIS - shared gui library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared gui library.

Package: libqgis-native3.40.11
Architecture: any
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: QGIS - shared native gui library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared native gui library.

Package: libqgis-server3.40.11
Architecture: any
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: QGIS - shared server library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared server library.

Package: libqgisgrass8-3.40.11
Architecture: any
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: QGIS - shared grass library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared grass library.

Package: libqgispython3.40.11
Architecture: any
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Replaces: libqgis3.40.11
Description: QGIS - shared Python library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared Python library.

Package: libqgis-customwidgets
Architecture: any
Depends:
 qttools5-dev-tools,
 ${shlibs:Depends},
 ${misc:Depends}
Description: QGIS custom widgets for Qt Designer
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains a library to use specific QGIS widgets in Qt Designer.

Package: libqgis-dev
Architecture: any
Section: libdevel
Depends:
 grass-dev,
 libexiv2-dev,
 libexpat1-dev,
 libgdal-dev (>= 1.11),
 libgeos-dev (>= 3.0.0),
 libgsl-dev,
 libpq-dev,
 libproj-dev,
 libqca-qt5-2-dev,
 libqgis-3d3.40.11 (= ${binary:Version}),
 libqgis-analysis3.40.11 (= ${binary:Version}),
 libqgis-app3.40.11 (= ${binary:Version}),
 libqgis-core3.40.11 (= ${binary:Version}),
 libqgis-gui3.40.11 (= ${binary:Version}),
 libqgis-native3.40.11 (= ${binary:Version}),
 libqgis-server3.40.11 (= ${binary:Version}),
 libqgisgrass8-3.40.11 (= ${binary:Version}),
 libqgispython3.40.11 (= ${binary:Version}),
 libqscintilla2-qt5-dev,
 libqt5svg5-dev,
 libqwt-qt5-dev,
 libsqlite3-dev,
 nlohmann-json3-dev,
 pyqt5-dev-tools,
 pyqt5.qsci-dev,
 python3-dev,
 python3-pyqt5,
 python3-pyqt5.qsci,
 python3-pyqt5.qtsql,
 qtbase5-dev,
 qtpositioning5-dev,
 qttools5-dev,
 ${misc:Depends}
Recommends: libqgis-customwidgets
Provides: qgis-dev
Description: QGIS - development files
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the headers and libraries needed to develop plugins for
 QGIS.

Package: qgis-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
 libqgis-3d3.40.11 (= ${binary:Version}),
 libqgis-analysis3.40.11 (= ${binary:Version}),
 libqgis-app3.40.11 (= ${binary:Version}),
 libqgis-core3.40.11 (= ${binary:Version}),
 libqgis-gui3.40.11 (= ${binary:Version}),
 libqgis-native3.40.11 (= ${binary:Version}),
 libqgis-server3.40.11 (= ${binary:Version}),
 libqgisgrass8-3.40.11 (= ${binary:Version}),
 libqgispython3.40.11 (= ${binary:Version}),
 ${misc:Depends}
Suggests: gdb
Description: QGIS - debugging symbols
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains debugging symbols.

Package: qgis-provider-grass
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: GRASS provider for QGIS
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This provider enables GRASS data access in QGIS.

Package: qgis-plugin-grass
Architecture: any
Depends:
 qgis (= ${binary:Version}),
 qgis-plugin-grass-common (= ${source:Version}),
 qgis-provider-grass (= ${binary:Version}),
 grass-core,
 ${grass:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: GRASS plugin for QGIS
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This plugin enables GRASS data access in QGIS.

Package: qgis-plugin-grass-common
Architecture: all
Depends:
 ${python3:Depends},
 ${misc:Depends}
Breaks: qgis-common (<< 1.5)
Replaces: qgis-common (<< 1.5)
Description: GRASS plugin for QGIS - architecture-independent data
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains architecture-independent supporting data files for use
 with the QGIS GRASS plugin.

Package: python3-qgis
Architecture: any
Section: python
Depends:
 python3-qgis-common (= ${source:Version}),
 qgis-providers (= ${binary:Version}),
 libqgispython3.40.11,
 libsqlite3-mod-spatialite,
 python3-jinja2,
 python3-owslib,
 python3-plotly,
 python3-psycopg2,
 python3-pygments,
 python3-pyproj,
 python3-pyqt5,
 python3-pyqt5.qsci,
 python3-pyqt5.qtsql,
 python3-pyqt5.qtmultimedia,
 python3-pyqt5.qtpositioning,
 python3-pyqt5.qtsvg,
 python3-pyqt5.qtserialport,
 python3-yaml,
 python3-lxml,
 ${python3:Depends},
 ${shlibs:Depends},
 ${sip3:Depends},
 ${misc:Depends}
Breaks: python-qgis (<< ${binary:Version})
Replaces: python-qgis (<< ${binary:Version})
Description: Python bindings to QGIS
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the files for the Python support.

Package: python3-qgis-common
Architecture: all
Section: python
Depends:
 gdal-bin,
 python3-gdal,
 python3-matplotlib,
 libqgis-customwidgets (>= ${source:Version}),
 ${python3:Depends},
 ${misc:Depends}
Breaks: python-qgis-common (<< ${source:Version})
Replaces: python-qgis-common (<< ${source:Version})
Suggests:
 saga
Description: Python bindings to QGIS - architecture-independent files
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains architecture-independent files for the QGIS Python
 bindings.

Package: qgis-providers
Architecture: any
Pre-Depends:
 dpkg (>= 1.16.1),
 ${misc:Pre-Depends}
Depends:
 qgis-providers-common (= ${source:Version}),
 libqca-qt5-2-plugins,
 libqt5sql5-sqlite,
 qt5-image-formats-plugins,
 qt5-image-formats-plugin-pdf,
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: qgis (<= 1.6)
Replaces: qgis (<= 1.6)
Description: collection of data providers to QGIS
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the provider plugins for QGIS.

Package: qgis-providers-common
Architecture: all
Depends: ${misc:Depends}
Breaks: qgis-common (<= 1.6)
Replaces: qgis-common (<= 1.6)
Description: collection of data providers to QGIS - architecture-independent files
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .

## qgis 3.40.11+git20251013+3df52a49d0a+43questing

=== debian/changelog ===
qgis (1:3.40.11+git20251013+3df52a49d0a+43questing) questing; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for questing

 -- Jürgen E. Fischer <jef@norbit.de>  Tue, 14 Oct 2025 08:35:00 +0000

## qgis 3.40.11+git20251017+f145b360740+17bookworm

=== debian/changelog ===
qgis (1:3.40.11+git20251017+f145b360740+17bookworm) bookworm; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for bookworm

 -- Jürgen E. Fischer <jef@norbit.de>  Sat, 18 Oct 2025 08:22:38 +0000

=== debian/control ===
--- 
+++ 
@@ -27,10 +27,12 @@
  libqt5serialport5-dev,
  libqt5sql5-sqlite,
  libqt5svg5-dev,
+ libqt5webkit5-dev,
  libqt5xmlpatterns5-dev,
  libdraco-dev,
  qtmultimedia5-dev,
  libqwt-qt5-dev,
+ libspatialindex-dev,
  libspatialite-dev,
  libsqlite3-dev,
  libsqlite3-mod-spatialite,
@@ -281,6 +283,7 @@
  libqgispython3.40.11 (= ${binary:Version}),
  libqscintilla2-qt5-dev,
  libqt5svg5-dev,
+ libqt5webkit5-dev,
  libqwt-qt5-dev,
  libsqlite3-dev,
  nlohmann-json3-dev,
@@ -386,6 +389,7 @@
  python3-pyqt5.qtmultimedia,
  python3-pyqt5.qtpositioning,
  python3-pyqt5.qtsvg,
+ python3-pyqt5.qtwebkit,
  python3-pyqt5.qtserialport,
  python3-yaml,
  python3-lxml,
@@ -450,5 +454,3 @@
 Replaces: qgis-common (<= 1.6)
 Description: collection of data providers to QGIS - architecture-independent files
  QGIS is a Geographic Information System (GIS) which manages, analyzes and
- display databases of geographic information.
- .

## qgis 3.40.11+git20251017+f145b360740+18trixie

=== CMakeLists.txt ===
#############################################################
# CMake settings
cmake_minimum_required(VERSION 3.12.0)
set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_AUTORCC ON)
# set path to additional CMake modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
# POLICIES
cmake_policy(SET CMP0048 NEW)
cmake_policy(SET CMP0053 NEW)
cmake_policy(SET CMP0071 NEW)
cmake_policy(SET CMP0094 NEW)
if(NOT "${CMAKE_VERSION}" VERSION_LESS "3.27")
  cmake_policy(SET CMP0144 NEW)
  # include(Dart) still used, as is the "Experimental" target
  cmake_policy(SET CMP0145 OLD)
endif()

# don't relink it only the shared object changes
set(CMAKE_LINK_DEPENDS_NO_SHARED ON)

set (WITH_BINDINGS TRUE CACHE BOOL "Determines whether Python bindings should be built")
set (WITH_3D TRUE CACHE BOOL "Determines whether QGIS 3D library should be built")
set (WITH_QGIS_PROCESS TRUE CACHE BOOL "Determines whether the standalone \"qgis_process\" tool should be built")
set (WITH_DESKTOP TRUE CACHE BOOL "Determines whether QGIS desktop should be built")
set (WITH_GUI TRUE CACHE BOOL "Determines whether QGIS GUI library should be built")
set(WITH_VCPKG FALSE CACHE BOOL "Use the vcpkg submodule for dependency management.")

set(SDK_PATH "" CACHE STRING "Build with VCPKG SDK")

if(NOT SDK_PATH STREQUAL "")
  message(STATUS "Building with SDK -- ${SDK_PATH}")
  set(CMAKE_TOOLCHAIN_FILE "${SDK_PATH}/scripts/buildsystems/vcpkg.cmake")
  set(VCPKG_INSTALL_PREFIX "${SDK_PATH}/installed")
  if(APPLE AND NOT VCPKG_TARGET_TRIPLET)
    set(VCPKG_TARGET_TRIPLET "x64-osx-dynamic")
  endif()
  set(WITH_VCPKG ON)
elseif(WITH_VCPKG)
  message(STATUS "Building local dependencies with VCPKG --")
  set(VCPKG_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/vcpkg_installed")
  include(VcpkgToolchain)
else()
  message(STATUS "Building with system libraries --")
endif()

if(WITH_VCPKG)
  list(APPEND CMAKE_PROGRAM_PATH "${VCPKG_INSTALL_PREFIX}/${VCPKG_TARGET_TRIPLET}/tools/python3/Scripts/")
  set(PREFER_INTERNAL_LIBS FALSE)
else()
  set(PREFER_INTERNAL_LIBS TRUE)
endif()

#############################################################
# Project and version
set(CPACK_PACKAGE_VERSION_MAJOR "3")
set(CPACK_PACKAGE_VERSION_MINOR "40")
set(CPACK_PACKAGE_VERSION_PATCH "11")
set(COMPLETE_VERSION ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH})
set(RELEASE_NAME "Bratislava")
project(qgis VERSION ${COMPLETE_VERSION})

if (APPLE)
  set(QGIS_APP_NAME "QGIS")
else()
  set(QGIS_APP_NAME "qgis")
endif()

# Note the version no is Mmmpp for Major/minor/patch, 0-padded, thus '10100' for 1.1.0
math(EXPR QGIS_VERSION_INT "${CPACK_PACKAGE_VERSION_MAJOR}*10000+${CPACK_PACKAGE_VERSION_MINOR}*100+${CPACK_PACKAGE_VERSION_PATCH}")
message(STATUS "QGIS version: ${COMPLETE_VERSION} ${RELEASE_NAME} (${QGIS_VERSION_INT})")

set (ENABLE_LOCAL_BUILD_SHORTCUTS FALSE CACHE BOOL "Disables some build steps which are only relevant for releases to speed up compilation time for development")

#############################################################
if (APPLE)
  # QGIS custom dependencies package from qgis/QGIS-Mac-Packager
  # they can be downloaded from https://qgis.org/downloads/macos/qgis-deps
  # and extracted to /opt/QGIS/qgis-deps-<deps-version>/stage
  set (QGIS_MAC_DEPS_DIR "" CACHE PATH "Path to QGIS Mac custom dependencies directory")

  # Setup LIB_DIR and CMAKE_PREFIX_PATH to help CMake's
  # find_packages to look for these libraries instead of system libraries
  if ( QGIS_MAC_DEPS_DIR )
    set(ENV{LIB_DIR} ${QGIS_MAC_DEPS_DIR})
    list(APPEND CMAKE_PREFIX_PATH ${QGIS_MAC_DEPS_DIR})
  endif()
endif()

#############################################################
# Configure OpenCL if available
set(HAVE_OPENCL FALSE)
if (${CMAKE_HOST_SYSTEM_NAME} MATCHES "BSD$")
  option(USE_OPENCL "Use OpenCL" OFF)
else()
  option(USE_OPENCL "Use OpenCL" ON)
endif()
if (USE_OPENCL)
    find_package(OpenCL)
    if(${OpenCL_FOUND})
        set(HAVE_OPENCL TRUE)
        # Fixup for standard FindOpenCL module not assigning proper framework headers directory
        if (APPLE AND "${OpenCL_INCLUDE_DIR}" MATCHES "OpenCL\\.framework/?$")
            set(OpenCL_INCLUDE_DIR "${OpenCL_INCLUDE_DIR}/Headers" CACHE PATH "" FORCE)
            set(OpenCL_INCLUDE_DIRS ${OpenCL_INCLUDE_DIR})
        endif()
        find_package(OpenCLhpp)
        if(NOT OPENCL_HPP_FOUND)
            # Use internal headers copied from OpenCL-CLHPP project
            set(OPENCL_HPP_INCLUDE_DIR ${CMAKE_SOURCE_DIR}/external/opencl-clhpp/include CACHE PATH "" FORCE)
            message(STATUS "Couldn't find OpenCL C++ headers, using internal: ${OPENCL_HPP_INCLUDE_DIR}")
        endif()
        set(OpenCL_INCLUDE_DIRS ${OpenCL_INCLUDE_DIRS} ${OPENCL_HPP_INCLUDE_DIR})
    else()
        message(STATUS "Couldn't find OpenCL: support DISABLED")
    endif()
endif()

# Configure CCache if available
option(USE_CCACHE "Use ccache" ON)
if (USE_CCACHE)
  find_program(CCACHE_FOUND ccache)
  if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    message(STATUS "ccache found")
  endif(CCACHE_FOUND)
endif(USE_CCACHE)

if (IOS)
    set (DEFAULT_FORCE_STATIC_LIBS TRUE)
else()
    set (DEFAULT_FORCE_STATIC_LIBS FALSE)
endif()

set (FORCE_STATIC_LIBS ${DEFAULT_FORCE_STATIC_LIBS} CACHE BOOL "Determines whether libraries should be static only")
mark_as_advanced(FORCE_STATIC_LIBS)
if (FORCE_STATIC_LIBS)
  set (LIBRARY_TYPE STATIC)
  # following variable is used in qgsconfig.h
  set (HAVE_STATIC_PROVIDERS TRUE)
else()
  set (LIBRARY_TYPE SHARED)
  unset(HAVE_STATIC_PROVIDERS)
endif()

# in generated makefiles use relative paths so the project dir is moveable
# Note commented out since it cause problems but it would be nice to resolve these and enable
#
# issue is caused by include_directories(${CMAKE_BINARY_DIR}) near the end of this file generating incorrect path
#set (CMAKE_USE_RELATIVE_PATHS ON)

set (WITH_CORE TRUE CACHE BOOL "Determines whether QGIS core should be built.")
mark_as_advanced(WITH_CORE)

if(WITH_CORE)
  # Try to configure and build GRASS plugin by default
  foreach (GRASS_SEARCH_VERSION 7 8)
    # Legacy note:
    # For GRASS 6 there were used cached variables without version suffix so that existing caches didn't have to be reconfigured.
    # Cached variables were: WITH_GRASS, WITH_GRASS7, GRASS_PREFIX, GRASS_PREFIX7, GRASS_INCLUDE_DIR, GRASS_INCLUDE_DIR7
    # Everywhere else each variable has version major appended.
    # Normal variables were: GRASS_FOUND6, GRASS_FOUND7, GRASS_MAJOR_VERSION6, GRASS_MAJOR_VERSION7, etc.
    # In addition there is also GRASS_FOUND, which is TRUE if at least one version of GRASS was found
    set (GRASS_CACHE_VERSION ${GRASS_SEARCH_VERSION})
    set (WITH_GRASS${GRASS_CACHE_VERSION} TRUE CACHE BOOL "Determines whether GRASS ${GRASS_SEARCH_VERSION} plugin should be built")
    if (WITH_GRASS${GRASS_CACHE_VERSION})
      find_package(GRASS ${GRASS_SEARCH_VERSION})
      set (GRASS_PREFIX${GRASS_CACHE_VERSION} ${GRASS_PREFIX${GRASS_SEARCH_VERSION}} CACHE PATH "Path to GRASS ${GRASS_SEARCH_VERSION} base directory")
    endif()
  endforeach (GRASS_SEARCH_VERSION)


  set (WITH_OAUTH2_PLUGIN TRUE CACHE BOOL "Determines whether OAuth2 authentication method plugin should be built")
  if(WITH_OAUTH2_PLUGIN)
    set(HAVE_OAUTH2_PLUGIN TRUE)
  endif()

  set (WITH_AUTH TRUE CACHE BOOL "Determines whether QGIS authentication methods should be built")

  set (WITH_ANALYSIS TRUE CACHE BOOL "Determines whether QGIS analysis library should be built")

  if(WITH_DESKTOP)
      if((WIN32 AND NOT MINGW) OR (UNIX AND NOT APPLE AND NOT ANDROID AND NOT IOS))
	set (CRASH_HANDLER_AVAILABLE TRUE)
      else()
	set (CRASH_HANDLER_AVAILABLE FALSE)
      endif()

      set (WITH_CRASH_HANDLER ${CRASH_HANDLER_AVAILABLE} CACHE BOOL "Determines whether the QGIS crash handler application should be built")
      if(WITH_CRASH_HANDLER AND NOT CRASH_HANDLER_AVAILABLE)
	message(FATAL_ERROR "Crash handler cannot be built on this environment. Set WITH_CRASH_HANDLER to false.")
      endif()
      if(WITH_CRASH_HANDLER)
	set (HAVE_CRASH_HANDLER TRUE)    # used in qgsconfig.h
      else()
	set (HAVE_CRASH_HANDLER FALSE)    # used in qgsconfig.h
      endif()
  endif()

  set (WITH_QUICK FALSE CACHE BOOL "Determines whether QGIS Quick library should be built")

  set (NATIVE_CRSSYNC_BIN "" CACHE PATH "Path to a natively compiled synccrsdb binary. If set, crssync will not build but use provided bin instead.")
  mark_as_advanced (NATIVE_CRSSYNC_BIN)

  # try to configure and build python bindings by default
  if (WITH_BINDINGS)
    # By default bindings will be installed only to QGIS directory
    # Someone might want to install it to python site-packages directory
    # as otherwise user has to use PYTHONPATH environment variable to add
    # QGIS bindings to package search path
    set (BINDINGS_GLOBAL_INSTALL FALSE CACHE BOOL "Install bindings to global Python directory? (might need root)")
    set (SIP_GLOBAL_INSTALL FALSE CACHE BOOL "Install sip source files to system sip directory? (might need root)")
    set (WITH_STAGED_PLUGINS TRUE CACHE BOOL "Stage-install core Python plugins to run from build directory? (utilities and console are always staged)")
    set (WITH_PY_COMPILE FALSE CACHE BOOL "Determines whether Python modules in staged or installed locations should be byte-compiled")
    # concatenate QScintilla2 API files
    if (WITH_GUI)
      set (WITH_QSCIAPI TRUE CACHE BOOL "Whether to generate PyQGIS QScintilla2 API file. (For devs) run 'make qsci-pap-src' in between QGIS build and install to regenerate .pap file in source tree for console auto-completion.")
      # keep casual users from updating their source tree via WITH_QSCIAPI
      mark_as_advanced (WITH_QSCIAPI)
    endif()
  endif()

  # server disabled default because it needs FastCGI (which is optional dependency)
  set (WITH_SERVER FALSE CACHE BOOL "Determines whether QGIS server should be built")
  if(WITH_SERVER)
    set (WITH_SERVER_LANDINGPAGE_WEBAPP FALSE CACHE BOOL "Determines whether QGIS server landingpage webapp should be built (requires nodejs and yarn)")

    set (SERVER_SKIP_ECW FALSE CACHE BOOL "Determines whether QGIS server should disable ECW (ECW in server apps requires a special license)")

    set (WITH_SERVER_PLUGINS ${WITH_BINDINGS} CACHE BOOL "Determines whether QGIS server support for Python plugins should be built")
    if(WITH_SERVER_PLUGINS AND NOT WITH_BINDINGS)
      message(FATAL_ERROR "Server plugins are not supported without Python bindings. Enable WITH_BINDINGS or disable WITH_SERVER_PLUGINS")
    endif()
    if(WITH_SERVER_PLUGINS)
      set(HAVE_SERVER_PYTHON_PLUGINS TRUE)
    endif()
  endif()

  # Custom widgets
  set (WITH_CUSTOM_WIDGETS FALSE CACHE BOOL "Determines whether QGIS custom widgets for Qt Designer should be built")

  if (NOT WITH_GUI)
    set (HAVE_GUI FALSE)    # used in qgsconfig.h
    # force value of some options
    if(WITH_DESKTOP)
      message(FATAL_ERROR "Desktop cannot be built without gui. Enable WITH_GUI or disable WITH_DESKTOP.")
    endif()
    if(WITH_CUSTOM_WIDGETS)
      message(FATAL_ERROR "Custom widgets cannot be built without gui. Enable WITH_GUI or disable WITH_CUSTOM_WIDGETS.")
    endif()
  else()
    set (HAVE_GUI TRUE)     # used in qgsconfig.h
  endif()

  if ( WITH_DESKTOP AND NOT WITH_ANALYSIS )
    message(FATAL_ERROR "Desktop cannot be built without analysis")
  endif()

  if ( WITH_QGIS_PROCESS AND NOT WITH_ANALYSIS )
    message(FATAL_ERROR "Process tool cannot be built without analysis")
  endif()

  if ( WITH_DESKTOP )
    # The qgis_desktop target is meant to build a minimal but complete running QGIS during development
    # This should help to reduce compile time while still having a "complete enough" QGIS for most of the development
    add_custom_target(qgis_desktop

=== debian/changelog ===
qgis (1:3.40.11+git20251017+f145b360740+18trixie) trixie; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for trixie

 -- Jürgen E. Fischer <jef@norbit.de>  Sat, 18 Oct 2025 12:12:59 +0000

## qgis 3.40.11+git20251017+f145b360740+36jammy

=== debian/changelog ===
qgis (1:3.40.11+git20251017+f145b360740+36jammy) jammy; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for jammy

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 17 Oct 2025 22:03:33 +0000

## qgis 3.40.11+git20251017+f145b360740+40noble-ubuntugis

=== debian/changelog ===
qgis (1:3.40.11+git20251017+f145b360740+40noble-ubuntugis) noble; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for noble-ubuntugis with
    ubuntugis dependencies

 -- Jürgen E. Fischer <jef@norbit.de>  Sat, 18 Oct 2025 03:05:45 +0000

## qgis 3.40.11+git20251017+f145b360740+42plucky

=== debian/changelog ===
qgis (1:3.40.11+git20251017+f145b360740+42plucky) plucky; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for plucky

 -- Jürgen E. Fischer <jef@norbit.de>  Sat, 18 Oct 2025 04:53:20 +0000

## qgis 3.40.11+git20251017+f145b360740+43questing

=== debian/changelog ===
qgis (1:3.40.11+git20251017+f145b360740+43questing) questing; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for questing

 -- Jürgen E. Fischer <jef@norbit.de>  Sat, 18 Oct 2025 06:43:50 +0000

## qgis 3.40.11+git20251017+f145b360740+99sid

=== debian/changelog ===
qgis (1:3.40.11+git20251017+f145b360740+99sid) sid; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for sid

 -- Jürgen E. Fischer <jef@norbit.de>  Sat, 18 Oct 2025 15:45:56 +0000

## qgis 3.40.11+git20251021+ba25deaaeb4+17bookworm

=== debian/changelog ===
qgis (1:3.40.11+git20251021+ba25deaaeb4+17bookworm) bookworm; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for bookworm

 -- Jürgen E. Fischer <jef@norbit.de>  Wed, 22 Oct 2025 07:44:05 +0000

## qgis 3.40.11+git20251021+ba25deaaeb4+18trixie

=== debian/changelog ===
qgis (1:3.40.11+git20251021+ba25deaaeb4+18trixie) trixie; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for trixie

 -- Jürgen E. Fischer <jef@norbit.de>  Wed, 22 Oct 2025 11:50:54 +0000

## qgis 3.40.11+git20251021+ba25deaaeb4+36jammy

=== debian/changelog ===
qgis (1:3.40.11+git20251021+ba25deaaeb4+36jammy) jammy; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for jammy

 -- Jürgen E. Fischer <jef@norbit.de>  Tue, 21 Oct 2025 21:20:31 +0000

=== debian/control ===
--- 
+++ 
@@ -74,6 +74,7 @@
  qtpositioning5-dev,
  qttools5-dev-tools,
  qttools5-dev,
+ libpdal-dev, pdal,
  libprotobuf-dev,
  protobuf-compiler,
  libzstd-dev,
@@ -222,7 +223,7 @@
  .
  This package contains the shared server library.
 
-Package: libqgisgrass8-3.40.11
+Package: libqgisgrass7-3.40.11
 Architecture: any
 Section: libs
 Depends:
@@ -279,7 +280,7 @@
  libqgis-gui3.40.11 (= ${binary:Version}),
  libqgis-native3.40.11 (= ${binary:Version}),
  libqgis-server3.40.11 (= ${binary:Version}),
- libqgisgrass8-3.40.11 (= ${binary:Version}),
+ libqgisgrass7-3.40.11 (= ${binary:Version}),
  libqgispython3.40.11 (= ${binary:Version}),
  libqscintilla2-qt5-dev,
  libqt5svg5-dev,
@@ -318,7 +319,7 @@
  libqgis-gui3.40.11 (= ${binary:Version}),
  libqgis-native3.40.11 (= ${binary:Version}),
  libqgis-server3.40.11 (= ${binary:Version}),
- libqgisgrass8-3.40.11 (= ${binary:Version}),
+ libqgisgrass7-3.40.11 (= ${binary:Version}),
  libqgispython3.40.11 (= ${binary:Version}),
  ${misc:Depends}
 Suggests: gdb
@@ -453,4 +454,3 @@
 Breaks: qgis-common (<= 1.6)
 Replaces: qgis-common (<= 1.6)
 Description: collection of data providers to QGIS - architecture-independent files
- QGIS is a Geographic Information System (GIS) which manages, analyzes and

## qgis 3.40.11+git20251021+ba25deaaeb4+36jammy-ubuntugis

=== debian/changelog ===
qgis (1:3.40.11+git20251021+ba25deaaeb4+36jammy-ubuntugis) jammy; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for jammy-ubuntugis with
    ubuntugis dependencies

 -- Jürgen E. Fischer <jef@norbit.de>  Tue, 21 Oct 2025 23:12:36 +0000

=== debian/control ===
--- 
+++ 
@@ -223,7 +223,7 @@
  .
  This package contains the shared server library.
 
-Package: libqgisgrass7-3.40.11
+Package: libqgisgrass8-3.40.11
 Architecture: any
 Section: libs
 Depends:
@@ -280,7 +280,7 @@
  libqgis-gui3.40.11 (= ${binary:Version}),
  libqgis-native3.40.11 (= ${binary:Version}),
  libqgis-server3.40.11 (= ${binary:Version}),
- libqgisgrass7-3.40.11 (= ${binary:Version}),
+ libqgisgrass8-3.40.11 (= ${binary:Version}),
  libqgispython3.40.11 (= ${binary:Version}),
  libqscintilla2-qt5-dev,
  libqt5svg5-dev,
@@ -319,7 +319,7 @@
  libqgis-gui3.40.11 (= ${binary:Version}),
  libqgis-native3.40.11 (= ${binary:Version}),
  libqgis-server3.40.11 (= ${binary:Version}),
- libqgisgrass7-3.40.11 (= ${binary:Version}),
+ libqgisgrass8-3.40.11 (= ${binary:Version}),
  libqgispython3.40.11 (= ${binary:Version}),
  ${misc:Depends}
 Suggests: gdb

## qgis 3.40.11+git20251021+ba25deaaeb4+40noble

=== debian/changelog ===
qgis (1:3.40.11+git20251021+ba25deaaeb4+40noble) noble; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for noble

 -- Jürgen E. Fischer <jef@norbit.de>  Wed, 22 Oct 2025 00:35:13 +0000

## qgis 3.40.11+git20251021+ba25deaaeb4+40noble-ubuntugis

=== debian/changelog ===
qgis (1:3.40.11+git20251021+ba25deaaeb4+40noble-ubuntugis) noble; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for noble-ubuntugis with
    ubuntugis dependencies

 -- Jürgen E. Fischer <jef@norbit.de>  Wed, 22 Oct 2025 02:19:39 +0000

## qgis 3.40.11+git20251021+ba25deaaeb4+42plucky

=== debian/changelog ===
qgis (1:3.40.11+git20251021+ba25deaaeb4+42plucky) plucky; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for plucky

 -- Jürgen E. Fischer <jef@norbit.de>  Wed, 22 Oct 2025 04:10:00 +0000

## qgis 3.40.11+git20251021+ba25deaaeb4+43questing

=== debian/changelog ===
qgis (1:3.40.11+git20251021+ba25deaaeb4+43questing) questing; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for questing

 -- Jürgen E. Fischer <jef@norbit.de>  Wed, 22 Oct 2025 05:59:09 +0000

## qgis 3.40.11+git20251021+ba25deaaeb4+99sid

=== python/pyplugin_installer/CMakeLists.txt ===
set (QGIS_PLUGININSTALLER_DIR ${QGIS_DATA_DIR}/python/pyplugin_installer)

set(PY_PLUGININSTALLER_FILES
    __init__.py
    installer.py
    installer_data.py
    qgsplugininstallerinstallingdialog.py
    qgsplugininstallerpluginerrordialog.py
    qgsplugininstallerfetchingdialog.py
    qgsplugininstallerrepositorydialog.py
    qgsplugindependenciesdialog.py
    plugindependencies.py
    unzip.py
    version_compare.py
)

set(UI_FILES
    qgsplugininstallerfetchingbase.ui
    qgsplugininstallerinstallingbase.ui
    qgsplugininstallerpluginerrorbase.ui
    qgsplugininstallerrepositorybase.ui
    qgsplugindependenciesdialogbase.ui
)

add_custom_target(pyplugin-installer ALL)

add_custom_command(TARGET pyplugin-installer
  POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E make_directory ${PYTHON_OUTPUT_DIRECTORY}/pyplugin_installer
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)
add_custom_command(TARGET pyplugin-installer
  POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E copy ${UI_FILES} ${PYTHON_OUTPUT_DIRECTORY}/pyplugin_installer
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS ${UI_FILES}
)

foreach(pyfile ${PY_PLUGININSTALLER_FILES})
  add_custom_command(TARGET pyplugin-installer
    POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy ${pyfile} ${PYTHON_OUTPUT_DIRECTORY}/pyplugin_installer
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${pyfile}
  )
endforeach(pyfile)
PY_COMPILE(pyplugin-installer "${PYTHON_OUTPUT_DIRECTORY}/pyplugin_installer")

install(FILES ${PY_PLUGININSTALLER_FILES} ${UI_FILES} DESTINATION "${QGIS_PLUGININSTALLER_DIR}")

=== tests/src/native/CMakeLists.txt ===
# Standard includes and utils to compile into all tests.

#####################################################
# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/src/test
  ${CMAKE_SOURCE_DIR}/src/native
  ${CMAKE_BINARY_DIR}/src/native
)

if(APPLE)
  include_directories(${CMAKE_SOURCE_DIR}/src/native/mac)
endif()

#############################################################
# Compiler defines

# This define is used for tests that need to locate the test
# data under tests/testdata in the qgis source tree.
# the TEST_DATA_DIR variable is set in the top level CMakeLists.txt
add_definitions(-DTEST_DATA_DIR="${TEST_DATA_DIR}")

add_definitions(-DINSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}")

#############################################################
# libraries

# because of htonl
if (WIN32)
  set(PLATFORM_LIBRARIES wsock32)
endif()

# Since the tests are not actually installed, but rather
# run directly from the build/src/tests dir we need to
# ensure the qgis libs can be found.
if (APPLE)
  # For Mac OS X, the executable must be at the root of the bundle's executable folder
#  set (CMAKE_INSTALL_NAME_DIR @executable_path/../../../src/core)
endif()



#############################################################
# Tests:

if (APPLE)
  add_qgis_test(testqgsmacnative.cpp MODULE native LINKEDLIBRARIES qgis_core qgis_native)
endif()

=== tests/src/3d/sandbox/CMakeLists.txt ===
if(WIN32)
  add_definitions(-DQWT_DLL)
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/tests/core #for render checker class
  ${CMAKE_SOURCE_DIR}/src/test
  ${CMAKE_SOURCE_DIR}/src/native

  ${CMAKE_BINARY_DIR}/src/ui
  ${CMAKE_BINARY_DIR}/src/native
  ${CMAKE_CURRENT_BINARY_DIR}

  ${CMAKE_SOURCE_DIR}/src/app/3d
  ${CMAKE_BINARY_DIR}/src/app
  ${QWT_INCLUDE_DIR}
)

include_directories(SYSTEM
  ${QT_INCLUDE_DIR}
  ${QT5_3DEXTRA_INCLUDE_DIR}
)

add_executable(qgis_3d_sandbox
  qgis_3d_sandbox.cpp
)
# require c++17
target_compile_features(qgis_3d_sandbox PRIVATE cxx_std_17)

set_target_properties(qgis_3d_sandbox PROPERTIES AUTORCC TRUE)
target_link_libraries(qgis_3d_sandbox
  ${QT_VERSION_BASE}::Xml
  ${QT_VERSION_BASE}::Core
  ${QT_VERSION_BASE}::Svg
  ${QT_VERSION_BASE}::Network
  ${QT_VERSION_BASE}::Test
  ${GEOS_LIBRARY}
  ${QWT_LIBRARY}
  qgis_core
  qgis_3d
  qgis_native
  qgis_app)

=== debian/changelog ===
qgis (1:3.40.11+git20251021+ba25deaaeb4+99sid) sid; urgency=medium

  * Release of 3.40.11
  * nightly build of long term release branch for sid

 -- Jürgen E. Fischer <jef@norbit.de>  Wed, 22 Oct 2025 15:47:49 +0000

## qgis 3.40.12%2Bdfsg

=== src/providers/mssql/CMakeLists.txt ===
set(MSSQL_SRCS
  qgsmssqlconnection.cpp
  qgsmssqlprovider.cpp
  qgsmssqlproviderconnection.cpp
  qgsmssqlgeometryparser.cpp
  qgsmssqltablemodel.cpp
  qgsmssqldataitems.cpp
  qgsmssqlexpressioncompiler.cpp
  qgsmssqlfeatureiterator.cpp
  qgsmssqlgeomcolumntypethread.cpp
  qgsmssqlsqlquerybuilder.cpp
  qgsmssqltransaction.cpp
  qgsmssqldatabase.cpp
)

if (WITH_GUI)
  set(MSSQL_SRCS ${MSSQL_SRCS}
    qgsmssqlprovidergui.cpp
    qgsmssqldataitemguiprovider.cpp
    qgsmssqlsourceselect.cpp
    qgsmssqlnewconnection.cpp
  )
endif()

set(MSSQL_HDRS
  qgsmssqlexpressioncompiler.h
)

########################################################
# Build

include_directories(

  ${CMAKE_BINARY_DIR}/src/ui
)


add_library(provider_mssql MODULE ${MSSQL_SRCS} ${MSSQL_HDRS})

# require c++17
target_compile_features(provider_mssql PRIVATE cxx_std_17)

target_compile_definitions(provider_mssql PRIVATE "CMAKE_SOURCE_DIR=\"${CMAKE_SOURCE_DIR}\"")

# We use private headers from core that need this
target_compile_definitions(provider_mssql PRIVATE "CMAKE_SOURCE_DIR=\"${CMAKE_SOURCE_DIR}\"")

target_link_libraries(provider_mssql
  qgis_core
  ${QT_VERSION_BASE}::Sql
)

if (WITH_GUI)
  target_link_libraries (provider_mssql
    qgis_gui
  )
  add_dependencies(provider_mssql ui)
endif()

# static library
add_library (provider_mssql_a STATIC ${MSSQL_SRCS} ${MSSQL_HDRS})

# require c++17
target_compile_features(provider_mssql_a PRIVATE cxx_std_17)

# We use private headers from core that need this
target_compile_definitions(provider_mssql_a PRIVATE "CMAKE_SOURCE_DIR=\"${CMAKE_SOURCE_DIR}\"")

target_link_libraries (provider_mssql_a
  qgis_core
  ${POSTGRES_LIBRARY}
  ${Qt5Xml_LIBRARIES}
  ${Qt5Core_LIBRARIES}
  ${Qt5Svg_LIBRARIES}
  ${Qt5Network_LIBRARIES}
  ${Qt5Sql_LIBRARIES}
  ${Qt5Concurrent_LIBRARIES}
)

if (WITH_GUI)
  target_link_libraries (provider_mssql_a
    qgis_gui
  )
  add_dependencies(provider_mssql_a ui)
endif()

########################################################
# Install

install (TARGETS provider_mssql
  RUNTIME DESTINATION ${QGIS_PLUGIN_DIR}
  LIBRARY DESTINATION ${QGIS_PLUGIN_DIR})

=== src/providers/wcs/CMakeLists.txt ===

set (WCS_SRCS
  ../../core/providers/gdal/qgsgdalproviderbase.cpp
  qgswcsprovider.cpp
  qgswcscapabilities.cpp
  qgswcsdataitems.cpp
)

if (WITH_GUI)
  set(WCS_GUI_SRCS
    qgswcsprovidergui.cpp
    qgswcsdataitemguiprovider.cpp
    qgswcssourceselect.cpp
  )
endif()

########################################################
# Static
add_library(provider_wcs_a STATIC ${WCS_SRCS})

target_include_directories(provider_wcs_a PUBLIC
  ${CMAKE_SOURCE_DIR}/src/providers/wcs
)

target_link_libraries(provider_wcs_a
  qgis_core
)

# require c++17
target_compile_features(provider_wcs_a PRIVATE cxx_std_17)

# We use private headers from core that need this
target_compile_definitions(provider_wcs_a PRIVATE "CMAKE_SOURCE_DIR=\"${CMAKE_SOURCE_DIR}\"")
target_compile_definitions(provider_wcs_a PRIVATE "-DQT_NO_FOREACH")

if (WITH_GUI)
  add_library(provider_wcs_gui_a STATIC ${WCS_GUI_SRCS})

  target_include_directories(provider_wcs_gui_a PUBLIC
    ${CMAKE_BINARY_DIR}/src/providers/wcs
  )

  target_link_libraries(provider_wcs_a
    qgis_gui
  )
  target_link_libraries(provider_wcs_gui_a
    qgis_gui
  )

  # require c++17
  target_compile_features(provider_wcs_gui_a PRIVATE cxx_std_17)

  target_compile_definitions(provider_wcs_gui_a PRIVATE "-DQT_NO_FOREACH")

  add_dependencies(provider_wcs_gui_a ui)

  include_directories(SYSTEM
    ${CMAKE_BINARY_DIR}/src/ui
  )
endif()

if (FORCE_STATIC_LIBS)
  # for (external) mobile apps to be able to pick up provider for linking
  install (TARGETS provider_wcs_a ARCHIVE DESTINATION ${QGIS_PLUGIN_DIR})
  if (WITH_GUI)
    install (TARGETS provider_wcs_gui_a ARCHIVE DESTINATION ${QGIS_PLUGIN_DIR})
  endif()
else()
  add_library(provider_wcs MODULE ${WCS_SRCS} ${WCS_GUI_SRCS})
  
  # require c++17
  target_compile_features(provider_wcs PRIVATE cxx_std_17)

  # We use private headers from core that need this
  target_compile_definitions(provider_wcs PRIVATE "CMAKE_SOURCE_DIR=\"${CMAKE_SOURCE_DIR}\"")
  
  target_link_libraries(provider_wcs
    qgis_core
  )
  
  if (WITH_GUI)
    target_link_libraries (provider_wcs
      qgis_gui
    )
  endif()
  
  install (TARGETS provider_wcs
    RUNTIME DESTINATION ${QGIS_PLUGIN_DIR}
    LIBRARY DESTINATION ${QGIS_PLUGIN_DIR}
  )
endif()

=== tests/src/analysis/CMakeLists.txt ===
# Standard includes and utils to compile into all tests.
set (util_SRCS)


#####################################################
# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/src/test
)

if(HAVE_OPENCL)
    include_directories(SYSTEM ${OpenCL_INCLUDE_DIRS})
endif()

#############################################################
# Tests:
set(TESTS
 testqgsgeometrysnapper.cpp
 testqgsinterpolator.cpp
 testqgsprocessingalgspt1.cpp
 testqgsprocessingalgspt2.cpp
 testqgsprocessingmodelalgorithm.cpp
 testqgszonalstatistics.cpp
 testqgsrastercalculator.cpp
 testqgsreclassifyutils.cpp
 testqgsalignraster.cpp
 testqgsnetworkanalysis.cpp
 testqgsninecellfilters.cpp
 testqgsmeshcalculator.cpp
 testqgsmeshcontours.cpp
 testqgstriangulation.cpp
)
if(HAVE_GSL)
  set(TESTS ${TESTS} testqgsgcptransformer.cpp)
endif()

if (WITH_PDAL AND PDAL_2_5_OR_HIGHER)
  set(TESTS ${TESTS} testqgsprocessingpdalalgs.cpp)
endif()

foreach(TESTSRC ${TESTS})
    add_qgis_test(${TESTSRC} MODULE analysis LINKEDLIBRARIES qgis_analysis)
endforeach(TESTSRC)
add_qgis_test(testqgsprocessing.cpp MODULE analysis LINKEDLIBRARIES qgis_analysis LABELS "POSTGRES")

=== tests/src/geometry_checker/CMakeLists.txt ===
# Standard includes and utils to compile into all tests.

#####################################################
# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/src/test
  ${CMAKE_SOURCE_DIR}/src/plugins

  ${CMAKE_BINARY_DIR}/src/analysis
)
include_directories(SYSTEM
  ${POSTGRES_INCLUDE_DIR}
)

#############################################################
# Tests:

add_qgis_test(testqgsgeometrychecks.cpp MODULE geometry_checker LINKEDLIBRARIES qgis_analysis)
add_qgis_test(testqgsvectorlayerfeaturepool.cpp MODULE geometry_checker LINKEDLIBRARIES qgis_analysis)

=== src/providers/grass/8/CMakeLists.txt ===
include_directories( SYSTEM
  ${GRASS_INCLUDE_DIR8}
)
include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
)
ADD_GRASSLIB(8)

=== python/plugins/processing/algs/qgis/CMakeLists.txt ===
file(GLOB PY_FILES *.py)
add_subdirectory(ui)

PLUGIN_INSTALL(processing algs/qgis ${PY_FILES})

## qgis 3.40.12+17bookworm

=== debian/changelog ===
qgis (1:3.40.12+17bookworm) bookworm; urgency=medium

  * Release of 3.40.12
  * long term release 3.40.12 for bookworm

 -- Jürgen E. Fischer <jef@norbit.de>  Tue, 28 Oct 2025 06:52:12 +0000

qgis (3.40.11) unstable; urgency=medium

  * Release of 3.40.11

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 24 Oct 2025 14:02:02 +0200

## qgis 3.40.12+18trixie

=== debian/changelog ===
qgis (1:3.40.12+18trixie) trixie; urgency=medium

  * Release of 3.40.12
  * long term release 3.40.12 for trixie

 -- Jürgen E. Fischer <jef@norbit.de>  Tue, 28 Oct 2025 10:52:22 +0000

## qgis 3.40.12+36jammy

=== debian/changelog ===
qgis (1:3.40.12+36jammy) jammy; urgency=medium

  * Release of 3.40.12
  * long term release 3.40.12 for jammy

 -- Jürgen E. Fischer <jef@norbit.de>  Mon, 27 Oct 2025 20:27:45 +0000
